#!/usr/bin/python2
# -*- Mode:python; c-file-style:"gnu"; indent-tabs-mode:nil -*- */
#
# Copyright (C) 2014 Arizona Board of Regents.
# Author: Yi Huang <ltr120@email.arizona.edu>
# See COPYING for copyright and distribution information.
#

import os
import unittest
import subprocess

class test_tcp_udp_tunnel(unittest.TestCase):
    """Test case for testing TCP/UDP tunnel"""

    errormsg = {
        1 : "Fail to create face",
        2 : "Interest loss detected",
    }

    def setUp(self):
        print "\nTesting TCP/UDP tunnel"
        print "**********************"
        os.chdir("test_tcp_udp_tunnel")

    def tearDown(self):
        print "**********************"
        os.chdir("..")

    def test_tcp4(self):
        print ">>> Testing with TCP4 <<<"
        ret = subprocess.call(["./tcp-udp-tunnel-test.sh tcp4"], shell=True)
        print "Test script return value:", ret
        if (ret != 0):
            self.fail(self.errormsg[ret])

    def test_udp4(self):
        print ">>> Testing with UDP4 <<<"
        ret = subprocess.call(["./tcp-udp-tunnel-test.sh udp4"], shell=True)
        print "Test script return value:", ret
        if (ret != 0):
            self.fail(self.errormsg[ret])

    def test_tcp6(self):
        print ">>> Testing with TCP6 <<<"
        ret = subprocess.call(["./tcp-udp-tunnel-test.sh tcp6"], shell=True)
        print "Test script return value:", ret
        if (ret != 0):
            self.fail(self.errormsg[ret])

    def test_udp6(self):
        print ">>> Testing with UDP6 <<<"
        ret = subprocess.call(["./tcp-udp-tunnel-test.sh udp6"], shell=True)
        print "Test script return value:", ret
        if (ret != 0):
            self.fail(self.errormsg[ret])
